免费注册 查看新帖 |

Chinaunix

  平台 论坛 博客 文库
最近访问板块 发新帖
查看: 4896 | 回复: 6
打印 上一主题 下一主题

shell脚本中. 起到了什么作用? [复制链接]

论坛徽章:
0
跳转到指定楼层
1 [收藏(0)] [报告]
发表于 2009-01-13 10:21 |只看该作者 |倒序浏览
这是一个/etc/init.d/hostname.sh的脚本


#! /bin/sh

### BEGIN INIT INFO

# Provides: hostname

# Required-Start:

# Required-Stop:

# Should-Start: glibc

# Default-Start: S

# Default-Stop:

# Short-Description: Set hostname based on /etc/hostname

# Description: Read the machines hostname from /etc/hostname, and

# update the kernel value with this value. If

# /etc/hostname is empty, the current kernel value

# for hostname is used. If the kernel value is

# empty, the value 'localhost' is used.

### END INIT INFO


PATH=/sbin:/bin

. /lib/init/vars.sh
. /lib/lsb/init-functions

do_start () {
    [ -f /etc/hostname ] && HOSTNAME="$(cat /etc/hostname)"

    # Keep current name if /etc/hostname is missing.

    [ -z "$HOSTNAME" ] && HOSTNAME="$(hostname)"

    # And set it to 'localhost' if no setting was found

    [ -z "$HOSTNAME" ] && HOSTNAME=localhost

    [ "$VERBOSE" != no ] && log_action_begin_msg "Setting hostname to '$HOSTNAME'"
    hostname "$HOSTNAME"
    ES=$?
    [ "$VERBOSE" != no ] && log_action_end_msg $ES
    exit $ES
}

case "$1" in
  start|"")
    do_start
    ;;
  restart|reload|force-reload)
    echo "Error: argument '$1' not supported" >&2
    exit 3
    ;;
  stop)
    # No-op

    ;;
  *)
    echo "Usage: hostname.sh [start|stop]" >&2
    exit 3
    ;;
esac


这里的. /lib/init/vars.sh 得到了什么?????

以下是/lib/init/vars.sh 的脚本
#
# Set rcS vars
#

[ -f /etc/default/rcS ] && . /etc/default/rcS
# Accept the same 'quiet' option as the kernel
if [ ! -e /proc/cmdline ] || egrep -qw 'quiet' /proc/cmdline ; then
    VERBOSE="no"
fi

# But allow both rcS and the kernel options 'quiet' to be overrided
# when INIT_VERBOSE=yes is used as well.
[ "$INIT_VERBOSE" ] && VERBOSE="$INIT_VERBOSE"






论坛徽章:
0
2 [报告]
发表于 2009-01-13 10:21 |只看该作者
执行脚本

论坛徽章:
8
摩羯座
日期:2014-11-26 18:59:452015亚冠之浦和红钻
日期:2015-06-23 19:10:532015亚冠之西悉尼流浪者
日期:2015-08-21 08:40:5815-16赛季CBA联赛之山东
日期:2016-01-31 18:25:0515-16赛季CBA联赛之四川
日期:2016-02-16 16:08:30程序设计版块每日发帖之星
日期:2016-06-29 06:20:002017金鸡报晓
日期:2017-01-10 15:19:5615-16赛季CBA联赛之佛山
日期:2017-02-27 20:41:19
3 [报告]
发表于 2009-01-13 10:24 |只看该作者

  1.         .  filename [arguments]
  2.        source filename [arguments]
  3.               Read  and  execute  commands from filename in the current shell
  4.               environment and return the exit status of the last command exe-
  5.               cuted  from  filename.   If  filename does not contain a slash,
  6.               file names in PATH are used to find  the  directory  containing
  7.               filename.   The  file  searched  for  in  PATH need not be exe-
  8.               cutable.  When bash is not in posix mode, the current directory
  9.               is  searched  if  no  file is found in PATH.  If the sourcepath
  10.               option to the shopt builtin command is turned off, the PATH  is
  11.               not  searched.   If any arguments are supplied, they become the
  12.               positional parameters when filename is executed.  Otherwise the
  13.               positional  parameters are unchanged.  The return status is the
  14.               status of the last command exited within the script  (0  if  no
  15.               commands  are  executed), and false if filename is not found or
  16.               cannot be read.
复制代码

论坛徽章:
0
4 [报告]
发表于 2009-01-13 10:50 |只看该作者

回复 #2 我是DBA 的帖子

. /lib/init/vars.sh  和 sh /lib/init/vars.sh  一样吗?

论坛徽章:
0
5 [报告]
发表于 2009-01-13 10:56 |只看该作者

回复 #4 adminsinx 的帖子

结果一样

论坛徽章:
0
6 [报告]
发表于 2009-01-13 11:14 |只看该作者
原帖由 adminsinx 于 2009-1-13 10:50 发表
. /lib/init/vars.sh  和 sh /lib/init/vars.sh  一样吗?


这要看从哪方面来分析。
. /lib/init/var.sh
在当前shell中执行脚本。

sh /lib/init/vars.sh
在子shell中执行脚本。
子shell中的变量不会影响到当前shell。

论坛徽章:
8
摩羯座
日期:2014-11-26 18:59:452015亚冠之浦和红钻
日期:2015-06-23 19:10:532015亚冠之西悉尼流浪者
日期:2015-08-21 08:40:5815-16赛季CBA联赛之山东
日期:2016-01-31 18:25:0515-16赛季CBA联赛之四川
日期:2016-02-16 16:08:30程序设计版块每日发帖之星
日期:2016-06-29 06:20:002017金鸡报晓
日期:2017-01-10 15:19:5615-16赛季CBA联赛之佛山
日期:2017-02-27 20:41:19
7 [报告]
发表于 2009-01-13 11:15 |只看该作者
原帖由 adminsinx 于 2009-1-13 10:50 发表
. /lib/init/vars.sh  和 sh /lib/init/vars.sh  一样吗?

不一样

Read  and  execute  commands from filename in the current shell
              environment
您需要登录后才可以回帖 登录 | 注册

本版积分规则 发表回复

  

北京盛拓优讯信息技术有限公司. 版权所有 京ICP备16024965号-6 北京市公安局海淀分局网监中心备案编号:11010802020122 niuxiaotong@pcpop.com 17352615567
未成年举报专区
中国互联网协会会员  联系我们:huangweiwei@itpub.net
感谢所有关心和支持过ChinaUnix的朋友们 转载本站内容请注明原作者名及出处

清除 Cookies - ChinaUnix - Archiver - WAP - TOP